<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'cancelPolicy' => '\\StructType\\CancelPolicy',
            'cancelPolicyResponse' => '\\StructType\\CancelPolicyResponse',
            'PolicyResp' => '\\StructType\\PolicyResp',
            'respError' => '\\StructType\\RespError',
            'sendPolicyAgreement' => '\\StructType\\SendPolicyAgreement',
            'sendPolicyAgreementResponse' => '\\StructType\\SendPolicyAgreementResponse',
            'SendPolicyResp' => '\\StructType\\SendPolicyResp',
            'getPolicyInfo' => '\\StructType\\GetPolicyInfo',
            'getPolicyInfoResponse' => '\\StructType\\GetPolicyInfoResponse',
            'PolicyInfoResp' => '\\StructType\\PolicyInfoResp',
            'PolicyInfo' => '\\StructType\\PolicyInfo',
            'InsuredPersonParms' => '\\StructType\\InsuredPersonParms',
            'supplementaries' => '\\StructType\\Supplementaries',
            'PolicyHolderParms' => '\\StructType\\PolicyHolderParms',
            'createPolicy' => '\\StructType\\CreatePolicy',
            'PolicyParms' => '\\StructType\\PolicyParms',
            'insureds' => '\\StructType\\Insureds',
            'createPolicyResponse' => '\\StructType\\CreatePolicyResponse',
            'getSuitableProductsOffer' => '\\StructType\\GetSuitableProductsOffer',
            'getSuitableProductsOfferResponse' => '\\StructType\\GetSuitableProductsOfferResponse',
            'SuitableProductsOfferResp' => '\\StructType\\SuitableProductsOfferResp',
            'SuitableProductOffer' => '\\StructType\\SuitableProductOffer',
            'SuitableTariffGroup' => '\\StructType\\SuitableTariffGroup',
            'SuitableTariff' => '\\StructType\\SuitableTariff',
            'getCheapestProduct' => '\\StructType\\GetCheapestProduct',
            'getCheapestProductResponse' => '\\StructType\\GetCheapestProductResponse',
            'ProductsOfferResp' => '\\StructType\\ProductsOfferResp',
            'ProductOffer' => '\\StructType\\ProductOffer',
            'getPolicyDraft' => '\\StructType\\GetPolicyDraft',
            'getPolicyDraftResponse' => '\\StructType\\GetPolicyDraftResponse',
            'DocumentDataResp' => '\\StructType\\DocumentDataResp',
            'documentData' => '\\StructType\\DocumentData',
            'getCompleteProductsOffer' => '\\StructType\\GetCompleteProductsOffer',
            'getCompleteProductsOfferResponse' => '\\StructType\\GetCompleteProductsOfferResponse',
            'getSupplementariesOffer' => '\\StructType\\GetSupplementariesOffer',
            'getSupplementariesOfferResponse' => '\\StructType\\GetSupplementariesOfferResponse',
            'SupplementariesOfferResp' => '\\StructType\\SupplementariesOfferResp',
            'SupplementaryTariffOffer' => '\\StructType\\SupplementaryTariffOffer',
            'getPolicyAgreement' => '\\StructType\\GetPolicyAgreement',
            'getPolicyAgreementResponse' => '\\StructType\\GetPolicyAgreementResponse',
            'userLogin' => '\\StructType\\UserLogin',
            'userLoginResponse' => '\\StructType\\UserLoginResponse',
            'loginResp' => '\\StructType\\LoginResp',
            'getProductsOffer' => '\\StructType\\GetProductsOffer',
            'getProductsOfferResponse' => '\\StructType\\GetProductsOfferResponse',
            'activatePolicy' => '\\StructType\\ActivatePolicy',
            'activatePolicyResponse' => '\\StructType\\ActivatePolicyResponse',
            'getProducts' => '\\StructType\\GetProducts',
            'getProductsResponse' => '\\StructType\\GetProductsResponse',
            'ProductsResp' => '\\StructType\\ProductsResp',
            'Product' => '\\StructType\\Product',
        );
    }
}
