<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DocumentDataResp StructType
 * @subpackage Structs
 */
class DocumentDataResp extends AbstractStructBase
{
    /**
     * The error
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RespError
     */
    public $error;
    /**
     * The documentData
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DocumentData
     */
    public $documentData;
    /**
     * Constructor method for DocumentDataResp
     * @uses DocumentDataResp::setError()
     * @uses DocumentDataResp::setDocumentData()
     * @param \StructType\RespError $error
     * @param \StructType\DocumentData $documentData
     */
    public function __construct(\StructType\RespError $error = null, \StructType\DocumentData $documentData = null)
    {
        $this
            ->setError($error)
            ->setDocumentData($documentData);
    }
    /**
     * Get error value
     * @return \StructType\RespError|null
     */
    public function getError()
    {
        return $this->error;
    }
    /**
     * Set error value
     * @param \StructType\RespError $error
     * @return \StructType\DocumentDataResp
     */
    public function setError(\StructType\RespError $error = null)
    {
        $this->error = $error;
        return $this;
    }
    /**
     * Get documentData value
     * @return \StructType\DocumentData|null
     */
    public function getDocumentData()
    {
        return $this->documentData;
    }
    /**
     * Set documentData value
     * @param \StructType\DocumentData $documentData
     * @return \StructType\DocumentDataResp
     */
    public function setDocumentData(\StructType\DocumentData $documentData = null)
    {
        $this->documentData = $documentData;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DocumentDataResp
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
