<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for insureds StructType
 * @subpackage Structs
 */
class Insureds extends AbstractStructBase
{
    /**
     * The insured
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\InsuredPersonParms[]
     */
    public $insured;
    /**
     * Constructor method for insureds
     * @uses Insureds::setInsured()
     * @param \StructType\InsuredPersonParms[] $insured
     */
    public function __construct(array $insured = array())
    {
        $this
            ->setInsured($insured);
    }
    /**
     * Get insured value
     * @return \StructType\InsuredPersonParms[]|null
     */
    public function getInsured()
    {
        return $this->insured;
    }
    /**
     * This method is responsible for validating the values passed to the setInsured method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInsured method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInsuredForArrayConstraintsFromSetInsured(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $insuredsInsuredItem) {
            // validation for constraint: itemType
            if (!$insuredsInsuredItem instanceof \StructType\InsuredPersonParms) {
                $invalidValues[] = is_object($insuredsInsuredItem) ? get_class($insuredsInsuredItem) : sprintf('%s(%s)', gettype($insuredsInsuredItem), var_export($insuredsInsuredItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The insured property can only contain items of type \StructType\InsuredPersonParms, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set insured value
     * @throws \InvalidArgumentException
     * @param \StructType\InsuredPersonParms[] $insured
     * @return \StructType\Insureds
     */
    public function setInsured(array $insured = array())
    {
        // validation for constraint: array
        if ('' !== ($insuredArrayErrorMessage = self::validateInsuredForArrayConstraintsFromSetInsured($insured))) {
            throw new \InvalidArgumentException($insuredArrayErrorMessage, __LINE__);
        }
        $this->insured = $insured;
        return $this;
    }
    /**
     * Add item to insured value
     * @throws \InvalidArgumentException
     * @param \StructType\InsuredPersonParms $item
     * @return \StructType\Insureds
     */
    public function addToInsured(\StructType\InsuredPersonParms $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InsuredPersonParms) {
            throw new \InvalidArgumentException(sprintf('The insured property can only contain items of type \StructType\InsuredPersonParms, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->insured[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Insureds
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
